<template>
  <main class="main-home main-inner-page">
    <section class="webinars">
      <div class="container">
        <p class="webinars__title">Онлайн-программы</p>
        <p class="webinars__subtitle">На онлайн-интенсиве всего за 1 час можно узнать как не платить штрафы, как вернуть права, выиграть суд и многое другое</p>
        <Loads :is-show="timetable"/>
        <slot
          v-for="(array, date, i) in timetable"
        >
          <div class="webinars-card"
               :key="array + date + id"
               v-if="Object.keys(array.rows).length && array.day === dateWebinars"
               v-for="(value, id) in array.rows"
          >
            <div class="webinars-card__top">
              <div class="webinars-card__top-time">{{value.time}}</div>
              <div class="webinars-card__top-places">{{value.cf[155]}} мест</div>
            </div>
            <div class="webinars-card__body">
              <div class="webinars-card__body-title">{{value.name}}</div>
              <div class="webinars-card__body-txt">{{value.cf[641]}}</div>
            </div>
            <div class="webinars-card__btn">
              <span style="margin-top: 6px; margin-right: 8px; opacity: .7; font-size: 15px"> {{value.cf[340] && value.cf[340] ? '0 руб' : '350 руб'}} </span>
              <a
                class="btn"
                @click="modal = true; value.cf[340] && value.cf[340] ? selected.price = 0 : selected.price = 350;  selected.name = value.name; timeWebinar = value.time"
              >Записаться</a>
            </div>
          </div>

          <div hidden class="arrow" v-else-if="i === (Object.keys(timetable).length - 1) && array.day !== dateWebinars && !Object.keys(array.rows).length">
            {{i + ' - это индекс итерации. Тут должна быть надпись, что по такой дате записей нет'}}
          </div>
        </slot>
      </div>
    </section>
    <Modal
      v-show="modal"
      @close="modal = false"
      :isClose="true"
      :is-policy="true"
    >
      <template v-slot:body>
        <form class="osago-form">
          <div class="osago-form__input">
            <input v-model="name" type="text" name="name" placeholder="Ваше имя">
          </div>
          <div class="osago-form__input">
            <input v-model="email" name="email" type="text" placeholder="Почта">
          </div>
          <div class="osago-form__input">
            <input v-model="phone" name="tel" data-inputmask="'mask': '+9(999)999-99-99'" type="text" placeholder="Телефон">
          </div>
          <p class="osago-form__agree">Отправляя форму вы даёте согласие на <a @click="$root.$refs.modal.showPolicy()">обработку персональных данных</a></p>
          <button class="btn btn--wide" @click.prevent="message">Записаться</button>
        </form>
      </template>
    </Modal>
  </main>
</template>

<script>
import axios from 'axios'
import Loads from './Loads'
import Modal from './Modal'
import Inputmask from 'inputmask'

export default {
  name: 'Webinars',
  components: {Modal, Loads},
  data () {
    return {
      timetable: null,
      dateWebinars: null,
      modal: false,
      phone: null,
      email: null,
      name: null,
      selected: {
        name: null,
        price: 350
      },
      timeWebinar: null
    }
  },
  computed: {
  },
  created () {
    this.$root.$refs.webinars = this
  },
  methods: {
    datepicker (e) {
      this.dateWebinars = e
    },
    message: function () {
      if (!this.name) {
        alert('Вам необходимо указать как вас зовут')
      } else if (!this.phone) {
        alert('Вам необходимо указать Ваш номер телефона')
      } else {
        const reg = '^\\+\\d{1,3}\\s?\\(\\d{3}\\)\\s?\\d{3}(-\\d{2}){2}$' // для проверки правильности введенного номера
        if (this.phone.match(reg) !== null) {
          let formData = new FormData()
          formData.append('crm', '11')
          formData.append('pipe', '22')
          formData.append('contact[name]', this.name)
          formData.append('contact[199]', this.phone)
          formData.append('contact[200]', this.email)
          formData.append('lead[214]', 'Приложение')
          formData.append('note', 'Заявка с приложения (вебинар) ' + '<br>' + 'Тема: ' + this.selected.name + '<br>' + 'Время вебинара: ' + `${this.dateWebinars} ${this.timeWebinar}`)

          axios.post('https://urist.v-avtoservice.com/api/import-lead',
            formData,
            {
              headers: {
                'Content-Type': 'multipart/form-data'
              }
            }
          ).then(res => {
            if (res.data.status === 'success') {
              this.modal = false
              alert('Заявка успешно отправлена!')
            }
          })
          formData = new FormData()
          formData.append('crm', '10')
          formData.append('pipe', '18')
          formData.append('contact[name]', this.name)
          formData.append('contact[151]', this.phone)
          formData.append('contact[152]', this.email)
          formData.append('lead[160]', `${this.dateWebinars} ${this.timeWebinar}`)
          formData.append('lead[161]', this.selected.name)
          formData.append('lead[price]', this.selected.price)
          axios.post('https://urist2.v-avtoservice.com/api/import-lead',
            formData,
            {
              headers: {
                'Content-Type': 'multipart/form-data'
              }
            }
          ).then(res => {
            if (res.data.link.result.payment_link) {
              window.location.href = res.data.link.result.payment_link
            }
          })
        } else {
          alert('Номер не корректный!')
        }
      }
    }
  },
  async mounted () {
    let date
    if (this.$root.$refs.header.dateWebinars) {
      date = new Date(this.$root.$refs.header.dateWebinars)
    } else {
      date = new Date()
    }
    const day = date.getDate() > 9 ? date.getDate() : `0${date.getDate()}`
    const month = (date.getMonth() + 1) > 9 ? (date.getMonth() + 1) : `0${(date.getMonth() + 1)}`
    this.dateWebinars = day + '.' + month + '.' + date.getFullYear() % 100
    // this.dateWebinars = day + '.' + month + '.' + date.getFullYear() % 100
    await axios.get('https://urist2.v-avtoservice.com/list/get-time-table').then(response => {
      this.timetable = response.data
      console.log(this.timetable)
    })
    Inputmask().mask(document.querySelectorAll('input[type=text]'))
  }
}
</script>

<style scoped>
.arrow:last-of-type{
  display:none;
}
</style>
